
vs.1.1

//------------------------------------------------------------------------------
// v0 = position
// v1 = blend weights
// v2 = blend indices
// v3 = normal
// v4 = texture coordinates
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// r0.w = Last blend weight
// r1 = Blend indices
// r2 = Temp position
// r3 = Temp normal
// r4 = Blended position in camera space
// r5 = Blended normal in camera space
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Constants specified by the app//
//
// c9-c95 = world-view matrix palette
// c8	  = diffuse * light.diffuse
// c7	  = ambient color
// c2-c5   = projection matrix
// c1	  = light direction
// c0	  = {1, power, 0, 1020.01}//
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// oPos	  = Output position
// oD0	  = Diffuse
// oD1	  = Specular
// oT0	  = texture coordinates
//------------------------------------------------------------------------------

dcl_position v0//
dcl_blendweight v1//
dcl_blendindices v2//
dcl_normal v3//
dcl_texcoord0 v7//
dcl_tangent v8//


// Compensate for lack of UBYTE4 on Geforce3
mul r1,v2.zyxw,c0.wwww
//mul r1,v2,c0.wwww


//Set 1
mov a0.x,r1.x
m4x3 r4.xyz,v0,c[a0.x + 9]//
m3x3 r8.xyz,v3,c[a0.x + 9]// 
mov r7.xyz,v8.xyz

//compute position
mov r4.w,c0.x
m4x4 oPos,r4,c2

mov r7.w, c32.w
mov r8.w, c32.w

//Cross product, flip orienation 
//may or may not be neccisary here 
//depending on the content
mul r0,r7.zxyw,-r8.yzxw//
mad r5,r7.yzxw,-r8.zxyw,-r0//

//transform the light vector
dp3 r6.x,r7,-c1
dp3 r6.y,r5,-c1
dp3 r6.z,r8,-c1

//bias around 128
add r6.xyz,r6.xyz,c32
mul r6.xyz,r6.xyz,c33
 
;mul r6.xyz, r6.xyz, c8.xyz
mov oD0.xyz, r6.xyz

mov oT0.xy,v7
mov oT1.xy,v7
mov oT2.xy,v7
mov oT3.xy,v7

